/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.capi.entities;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

/**
 * @author ctabin
 */
@Entity
public class Address implements Serializable
{
    //---------//
    //Constants//
    //---------//

    //---------//
    //Variables//
    //---------//

    @Id
    @GeneratedValue
    @Column(name="addressId")
    private int id;

    @Column(name="npaAddress")
    private String npa;

    @Column(name="cityAddress")
    private String city;

    @ManyToOne
    @JoinColumn(name="personId", referencedColumnName="personId")
    private Person person;

    //-----------//
    //Constructor//
    //-----------//

    /**
     * Creates a new Address object.
     */
    public Address() {}

    public Address(Person person, String npa, String city)
    {
        this.person = person;
        this.npa = npa;
        this.city = city;

        person.getAdresses().add(this);
    }

    //--------------//
    //Public methods//
    //--------------//

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getNpa() {
        return npa;
    }

    public void setNpa(String npa) {
        this.npa = npa;
    }

    public Person getPerson() {
        return person;
    }

    public void setPerson(Person person) {
        this.person = person;
    }

    @Override
    public String toString()
    {
        return "Adresse of "+person.getName()+" => "+npa+" "+city;
    }

    //-----------------//
    //Protected methods//
    //-----------------//

    //---------------//
    //Private methods//
    //---------------//
}
