/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.capi.entities;

import java.io.Serializable;
import java.util.LinkedList;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;


/**
 * @author ctabin
 */
@Entity
public class Person implements Serializable
{
    //---------//
    //Constants//
    //---------//

    //---------//
    //Variables//
    //---------//

    @Id
    @GeneratedValue
    @Column(name="personId")
    private int id;

    @Column(name="namePerson")
    private String name;

    @Column(name="loginPerson")
    private String login;

    @OneToMany(mappedBy="person")
    private List<Address> addresses;

    //-----------//
    //Constructor//
    //-----------//

    /**
     * Creates a new Person object.
     */
    public Person() {}

    public Person(String name, String login)
    {
        this.name = name;
        this.login = login;
        this.addresses = new LinkedList<Address>();
    }

    //--------------//
    //Public methods//
    //--------------//

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getLogin() {
        return login;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<Address> getAdresses() {
        return addresses;
    }

    public void setAdresses(List<Address> adresses) {
        this.addresses = adresses;
    }

    @Override
    public String toString()
    {
        return id+" -> "+name+" ("+login+") with "+addresses.size()+" addresses.";
    }

    //-----------------//
    //Protected methods//
    //-----------------//

    //---------------//
    //Private methods//
    //---------------//
}
