/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.capi.facade;

import ch.capi.entities.Address;
import ch.capi.entities.Person;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author ctabin
 */
@Stateless
public class FacadeBean implements FacadeBeanRemote {
    
    @PersistenceContext
    private EntityManager entityManager;

    public void create()
    {
        //creates some people
        Person p1 = new Person("Cédric", "cedric1337");
        Person p2 = new Person("Raphaël", "raphael32");
        Person p3 = new Person("Jacques", "jacques1024");
        Person p4 = new Person("John", "john256");

        //creates some adresses
        Address a1 = new Address(p1, "3960", "Sierre");
        Address a2 = new Address(p1, "1018", "Lausanne");
        Address a3 = new Address(p2, "3960", "Sierre");
        Address a4 = new Address(p4, "1018", "Lausanne");
        Address a5 = new Address(p4, "1951", "Sion");
        Address a6 = new Address(p4, "3960", "Sierre");

        //persist
        entityManager.persist(p1);
        entityManager.persist(p2);
        entityManager.persist(p3);
        entityManager.persist(p4);
        entityManager.persist(a1);
        entityManager.persist(a2);
        entityManager.persist(a3);
        entityManager.persist(a4);
        entityManager.persist(a5);
        entityManager.persist(a6);
    }

    public void reset()
    {
        Query deleteAdresses = entityManager.createQuery("DELETE FROM Address a");
        Query deletePeople = entityManager.createQuery("DELETE FROM Person p");

        deleteAdresses.executeUpdate();
        deletePeople.executeUpdate();
    }

    public String executeQuery(String jpqlQuery)
    {
        try
        {
            StringBuilder builder = new StringBuilder();
            Query q = entityManager.createQuery(jpqlQuery);
            List objects = q.getResultList();

            builder.append("<br />");
            for (Object o : objects)
            {
                builder.append(o).append("<br />");
            }

            return builder.toString();
        }
        catch(Exception e)
        {
            return "ERROR : "+e.getMessage();
        }
    }
}
